'C019a 'Wywietlanie biegncego napisu z pamieci FLASH
' wersja z pomocniczymi zmiennymi R1...R4 i poleceniem Lookup
Dim R1 As Byte , R2 As Byte , R3 As Byte , R4 As Byte       'cztery literki
Dim Licznik As Byte , Mux As Byte , Dlugosc As Byte
Config Portb = 255 : Portb = 255 : Config Portd = &B1111100 : Portd = &B1111111
Config Timer0 = Timer , Prescale = 64 : Config Timer1 = Timer , Prescale = 64
Enable Interrupts : Enable Timer0 : Enable Timer1       'odblokowanie przerwa
On Timer0 Co4ms : On Timer1 Skok       'po przepenieniu licznikw skocz
R4 = 255 : R3 = 255 : R2 = 255 : R1 = 255       'na pocztek wygasza wszystko
'Licznik = 0       'zaczyna od pierwszej literki - ta linia nie jest niezbdna
                              'bo zmienne w pamici RAM s zerowane po resecie
Do : Loop : End     'to jest gwny program -  pusta nieskoczona ptla

Skok:               'co 0,25s przesuwa napis o jedno miejsce w lewo
Timer1 = 50000      'tu skracamy cykl zliczania T1 do ok. 0,25s (15536*16us)
R4 = R3             'tu jest przesuwanie w lewo
R3 = R2             'kolejnych czterech aktualnie wywietlanych
R2 = R1             'literek napisu
R1 = Lookup(licznik , Dluginapis)       'pobiera jedn now literk z pamici
Incr Licznik        'potem bdzie kolejna literka
If Licznik = 68 Then Licznik = 0       'wr na pocztek napisu
Return

Co4ms:              'przerwanie co 4,096ms (bez skracania cyklu)
Incr Mux : If Mux = 4 Then Mux = 0       ' liczy do 4 (0...3)
Portd = &B1111111   'wyga wywietlacz
Select Case Mux
Case 0:             '               na prawym wywietlaczu
   Portb = R1 : Portd.3 = 0       ' wywietl zawarto R1
Case 1:
   Portb = R2 : Portd.4 = 0       ' wywietl zawarto R2
Case 2:
   Portb = R3 : Portd.5 = 0       ' wywietl zawarto R3
Case 3:             '               na lewym wywietlaczu
   Portb = R4 : Portd.6 = 0       ' wywietl zawarto R4
End Select
Return              'koniec obsugi przerwania od T/C0 co 4,096ms

Dluginapis:         'tu jest dugi napis - dane w pamici FLASH
Data 140 , 134 , 136 , 198 , 134 , 255 , 142 , 163 , 175 , 255 , 136 , 199 , 199
Data 255 , 140 , 134 , 192 , 140 , 199 , 134 , 255 , 191 , 136 , 131 , 167 , 198
Data 161 , 134 , 142 , 194 , 137 , 139 , 239 , 251 , 207 , 249 , 241 , 199 , 171
Data 163 , 192 , 140 , 175 , 146 , 135 , 193 , 227 , 255 , 191 , 255 , 161 , 134
Data 146 , 207 , 194 , 171 , 255 , 191 , 255 , 140 , 251 , 163 , 135 , 175 , 255
Data 66 , 255 , 255