'C019j  Licznik rewersyjny 0...250 z konwersj BCD; w liczniku wstpnie liczba 137
$eeprom
Tabela:             'kody cyfr 0...9 + kod wygaszenia + wstpna zawartos zm. Licznik
Data 192 , 249 , 164 , 176 , 153 , 146 , 130 , 248 , 128 , 144 , 255 , 137
Dim Setki As Byte , Licznik As Eram Byte At 11       ' teraz zmienna jest w komrce 11
Dim Jednostki As Byte , Dziesiatki As Byte , Mux As Byte , Wpis As Bit , Maxi As Byte
Dim Uniwers As Byte , Pomoc As Byte , A As Byte , Zero As Byte , Przyciski As Byte
Config Portb = 255 : Portb = 255 : Config Portd = &B1111100 : Portd = 127
Config Timer0 = Timer , Prescale = 64 : Enable Interrupts : Enable Timer0
On Timer0 Co4ms : Uniwers = 4 : Maxi = 60       'wartoci pocztkowe
Zero = 192          'bo nie mona wpisa liczby wprost do EEPROM-a
Writeeeprom Zero , 0       'na wszelki wypadek
Pomoc = Licznik     ' jednorazowo na pocztku przepisujemy z EEPROMa do RAM-u
Do : Loop : End     'to jest gwny program -  pusta nieskoczona ptla

Co4ms:              'przerwanie co 4,096ms
Decr Uniwers        'klasyczna obsuga "inteligentnych" przyciskw
If Uniwers = 0 Then ' na koniec cyklu licznika Uniwers:
   Przyciski = Pind 'nie mona wsprost z siedmiobitowym rejestrem Pind
   Przyciski = Przyciski And &B11       ' "wydubujemy" dwa najmodsze bity
   Select Case Przyciski       'sprawdzamy stan przyciskw
   Case 1:          'Pind.1 = 0 and Pind.0 = 1      ' przycisk "d" - S2
     Maxi = Maxi - 8 : If Maxi < 8 Then Maxi = 8 : Uniwers = Maxi       'coraz szybciej
     Wpis = 1       'ustaw flag nacinicia przyscisku
     Decr Pomoc     'zmniejsza, ale nie wpisuje do EEPROM-a
     If Pomoc = 255 Then Pomoc = 0       'nie pozwala na "zawiniecie" gdy dojdzie do 0
   Case 2:          ' Pind.0 = 0 And Pind.1 = 1 Then  'przycisk "gra" - S1
     Maxi = Maxi - 8 : If Maxi < 8 Then Maxi = 8 : Uniwers = Maxi       'coraz szybciej
     Wpis = 1       'ustaw flag nacinicia przyscisku
     Incr Pomoc     'zwiksza, ale nie wpisuje do EEPROM-a
     If Pomoc = 251 Then Pomoc = 250       'liczy 0...250
   Case Else:       'gdy S1, S2 zwolnione lub oba nacinite
     Uniwers = 4 : Maxi = 60       'zwyky cykl Uniwers (4...0)
     If Wpis = 1 Then       'po zwolnieniu przycisku
        Wpis = 0    '        jednorazowo
        Licznik = Pomoc       ' wpisuje now warto do EEPROM
     End If         '
   End Select
End If
'konwersja liczby 8-bitowej  na 3 cyfrow BCD - wynik w zmiennych bajtowych: A i Setki
A = Pomoc           'liczb do wywietlenia przepisujemy do zmiennej pomocniczej A
If A < 100 Then     'dla liczb 0...99
   Setki = 10       'wygasi w nietypowy sposb wywietlacz setek
Else                'jeli liczba A wiksza od 99
   A = A - 100
   If A < 100 Then  'dla liczb 100...199
      Setki = 1
   Else             'dla liczb>=200
      Setki = 2
      A = A - 100
   End If
End If              'teraz  w zmiennej A na pewno jest liczba 0...99
A = Makebcd(a)      'zamieniamy liczb dwjkow na BCD
Jednostki = A And 15 : Dziesiatki = A : Shift Dziesiatki , Right , 4
Mux = Uniwers And &B11 : Portd = 127       'aktywne i wygaszone cztery wywietlacze
Select Case Mux     ' obsuga wywietlacza
Case 0:             'wywietl warto  jednostek
  Readeeprom Portb , Jednostki : Portd.3 = 0
Case 1:             'wywietl warto  dziesitek
  Readeeprom Portb , Dziesiatki : Portd.4 = 0 : Portb.7 = 0       'punkt dziesitny
Case 2:             'wywietl warto setek lub wyga
  Readeeprom Portb , Setki : Portd.5 = 0
Case 3:             'na lewym wywietlaczu poka dodatkow literk
'   Portb = &B01111011 : Portd.6 = 0       'na lewym wywietlaczu literka i z kropk
   Portb = &B01100011 : Portd.6 = 0       'na lewym wywietlaczu literka u z kropk
End Select : Return 'koniec obsugi przerwania od T/C0 co 4,096ms