'C019technikalia  sprawdzenie, czy w trakcie zapisywania EEPROM-a
' pozwala realizowa program, czy go zatrzymuje
'liczba na wywietlaczu pokazuje czas, cilej liczb "obrotw" ptli
'Po zaprogramowaniu od razu program startuje i pokazuje wynik.
'Kade zresetowanie procesora (zwarcie kokw R, G) rozpoczyna nowy cykl pracy
' - wynik pozostaje ten sam, bo przy danym zasilaniu czas zapisu jest stay

' UWAGA! Mona sprawdzi czas zapisu przy rnych napiciach zasilania
' W tym celu po zaprogramowaniu procesora trzeba odczy wtyk programatora
' a doczy zasilacz regulowany w zakresie 2,7 ...6,0V
' Potem po kadej zmianie napicia zewrze koki resetu (R, G), co zapocztkuje nowy cykl pracy
'
'!!!!   NIE PREZEKROCZY NAPICIA ZASILANIA 6V    !!!!!!!!!



' WERSJA 1 z pomiarem w ptli DO...LOOP (mao dokadna)
' niemniej udowadnia, e zapis pamici nie przerywa pracy programu
$eeprom
Tabela:             'kody cyfr 0...9 + kod wygaszenia
Data 192 , 249 , 164 , 176 , 153 , 146 , 130 , 248 , 128 , 144 , 255 , 137
Dim Setki As Byte , Jednostki As Byte , Dziesiatki As Byte , Mux As Byte
Dim , Pomoc As Byte , A As Byte , Zero As Byte
Config Portb = 255 : Portb = 255 : Config Portd = &B1111100 : Portd = 127
Zero = 192 : Pomoc = 0
'a teraz jednokrotnie wpisz cokolwiek do komrki EEPROM-a:
Writeeeprom Zero , 0       'sprawdzimy czas tego wpisywania w ptli:

Do                  'szacunkowy czas obiegu ptli
Waitus 95           '  okoo 100 mikrosekund
If Eecr.1 = 1 Then  'tylko  jeli komrka jeszcze nie zapisana
  Incr Pomoc        'zwiksz licznik (co okoo 0,1ms)
'  Jeeli w trakcie zapisu do EEPROM-a, gdy EECR=1 procesor nie wykonywaby
' "normalnego" programu, zmienna Pomoc nie byaby zwikszana i wskazanie byoby 0
'Jeeli podczas zapisu EEPROM-a program, a konkretnie ptla "obraca si"  co 0,1ms,
'na wywietlaczu pokae si liczba obiegw ptli podczas zapisu komrki
Else                ' a dopiero po zapisaniu komrki EEPROM-a wywietl wynik:
   'konwersja liczby 8-bitowej  na 3 cyfrow BCD - wynik w zmiennych bajtowych: A i Setki
   A = Pomoc           'liczb do wywietlenia przepisujemy do zmiennej pomocniczej A
   If A < 100 Then     'dla liczb 0...99
      Setki = 10    'wygasi w nietypowy sposb wywietlacz setek
   Else                'jeli liczba A wiksza od 99
      A = A - 100
      If A < 100 Then  'dla liczb 100...199
         Setki = 1
      Else             'dla liczb>=200
         Setki = 2
         A = A - 100
      End If
   End If              'teraz  w zmiennej A na pewno jest liczba 0...99
   A = Makebcd(a)      'zamieniamy liczb dwjkow na BCD
   Jednostki = A And 15 : Dziesiatki = A : Shift Dziesiatki , Right , 4
   Incr Mux : If Mux = 4 Then Mux = 0 : Portd = 127
   Select Case Mux     ' obsuga wywietlacza
   Case 0:             'wywietl warto  jednostek
     Readeeprom Portb , Jednostki : Portd.3 = 0
   Case 1:             'wywietl warto  dziesitek
     Readeeprom Portb , Dziesiatki : Portd.4 = 0 : Portb.7 = 0
   Case 2:             'wywietl warto setek lub wyga
     Readeeprom Portb , Setki : Portd.5 = 0
   Case 3:             'na lewym wywietlaczu poka dodatkow literk
     Portb = &B00000111 : Portd.6 = 0       'na lewym wywietlaczu literka t z kropk
   End Select
End If
Loop
End                 'to jest gwny program -  pusta nieskoczona ptla




'(

' WERSJA 2 z przerwaniem co 100us (dokadniejsza)
'potwierdza, e zapis EEEPROM-a nie blokuje te systemu przerwa
$eeprom
Tabela:             'kody cyfr 0...9 + kod wygaszenia
Data 192 , 249 , 164 , 176 , 153 , 146 , 130 , 248 , 128 , 144 , 255 , 137
Dim Setki As Byte , Jednostki As Byte , Dziesiatki As Byte , Mux As Byte ,
Dim Pomoc As Byte , A As Byte , Zero As Byte
Config Portb = 255 : Portb = 255 : Config Portd = &B1111100 : Portd = 127
Config Timer0 = Timer , Prescale = 8       'impuls co 2us
Enable Interrupts : Enable Timer0
On Timer0 Co100us : Zero = 192 : Pomoc = 0
'a teraz jednokrotnie wpisz do komrki EEPROM-a:
Writeeeprom Zero , 0       'sprawdzimy czas tego wpisywania w ptli:

Do : Loop : End     'to jest gwny program -  pusta nieskoczona ptla

Co100us:            'przerwanie co 0,1ms
Timer0 = 206        '50 x 2us = 0,1ms    (256-206)
If Eecr.1 = 1 Then  'tylko na pocztku, jeli komrka jeszcze nie zapisana
  Incr Pomoc        'zwiksz licznik, ale nie wywietlaj
Else                'dopiero po zapisanu komrki wywietl wynik:
   'konwersja liczby 8-bitowej  na 3 cyfrow BCD - wynik w zmiennych bajtowych: A i Setki
   A = Pomoc           'liczb do wywietlenia przepisujemy do zmiennej pomocniczej A
   If A < 100 Then     'dla liczb 0...99
      Setki = 10       'wygasi w nietypowy sposb wywietlacz setek
   Else                'jeli liczba A wiksza od 99
      A = A - 100
      If A < 100 Then  'dla liczb 100...199
         Setki = 1
      Else             'dla liczb>=200
         Setki = 2
         A = A - 100
      End If
   End If              'teraz  w zmiennej A na pewno jest liczba 0...99
   A = Makebcd(a)      'zamieniamy liczb dwjkow na BCD
   Jednostki = A And 15 : Dziesiatki = A : Shift Dziesiatki , Right , 4
   Incr Mux : If Mux = 4 Then Mux = 0 : Portd = 127
   Select Case Mux     ' obsuga wywietlacza
   Case 0:             'wywietl warto  jednostek
     Readeeprom Portb , Jednostki : Portd.3 = 0
   Case 1:             'wywietl warto  dziesitek
     Readeeprom Portb , Dziesiatki : Portd.4 = 0 : Portb.7 = 0
   Case 2:             'wywietl warto setek lub wyga
     Readeeprom Portb , Setki : Portd.5 = 0
   Case 3:             'na lewym wywietlaczu poka dodatkow literk
     Portb = &B00000111 : Portd.6 = 0       'na lewym wywietlaczu literka t z kropk
   End Select
End If
Return              'koniec obsugi przerwania od T/C0 co 0,1ms

')

