'C016b  Prosty zegar z "duymi" licznikami i konwersj BCD
Dim Sekundy As Byte , Minuty As Byte , Godziny As Byte , Uniwers As Byte
Dim Sekjed As Byte , Sekdzies As Byte , Minjed As Byte , Mindzies As Byte
Dim Godzjed As Byte , Godzdzies As Byte , Mux As Byte , Migaj As Bit  , Maxi As Byte
Config Portb = 255 : Portb = 255 : Config Portd = &B1111100 : Portd = &B1111111
Config Timer0 = Timer , Prescale = 64 : Config Timer1 = Timer , Prescale = 64
Enable Interrupts : Enable Timer0 : Enable Timer1       'odblokowanie przerwa
On Timer0 Co4ms : On Timer1 Co1s Nosave       'po przepenieniu licznikw skocz
Uniwers = 4 : Maxi = 100    'wartoci pocztkowe zmiennych pomocniczych

Do : Loop : End             'to jest gwny program -  pusta nieskoczona ptla

Co1s:                       'co 1 sekund
Load Timer1 , 62500 : Incr Sekundy : Toggle Migaj : Return

Co4ms:                      'przerwanie co 4,096ms (bez skracania cyklu)
Decr Uniwers                'obsuga wywietlaczy i przyciskw
If Pind.1 = 0 And Pind.0 = 1 Then       'gdy przycisk "minuty" - S2 nacinity
   If Uniwers = 0 Then
      Uniwers = Maxi : Incr Minuty : Sekundy = 0       ' zeruje sekundy
      Maxi = Maxi - 8 : If Maxi < 8 Then Maxi = 8       'coraz szybciej
End If : End If
If Pind.0 = 0 And Pind.1 = 1 Then       'gdy przycisk "godziny" - S1 nacinity
   If Uniwers = 0 Then      'licznik pomocniczy Uniwers
      Uniwers = Maxi : Incr Godziny
      Maxi = Maxi - 8 : If Maxi < 12 Then Maxi = 12       '  coraz szybciej
End If : Else               'gdy S1, S2 zwolnione lub oba nacinite
   If Uniwers = 0 Then      'licznik Uniwers
      Uniwers = 4 : Maxi = 100
   End If : End If
' co 4ms sprawdzamy i korygujemy stany licznikw
If Sekundy = 60 Then        'skrc cykl licznika sekund: 0...59 , itd...
   Sekundy = 0 : Incr Minuty
End If                      'tym razem nie zagniedzamy procedur sprawdzania,
If Minuty = 60 Then         ' - zagniedenie spowodowaoby bdy podczas
   Minuty = 0 : Incr Godziny       '   ustawiania zegara
End If                      '
If Godziny = 24 Then        '
   Godziny = 0
End If
'teraz zamieniamy liczby dwjkowe na BCD
Mindzies = Makebcd(minuty)  'zamieniamy liczb dwjkow na BCD
Minjed = Mindzies And 15    'przez polecenie AND i mask &B00001111 = 15
'uzyskujemy tylko cztery modsze bity, czyli jednostki minut
Shift Mindzies , Right , 4  'przesuwajc w prawo usuwany 4 modsze bity
'pozostaj dziesitki minut w czterech modszych bitach
'a w czterech starszych s zera - tak przecie dziaa polecenie SHIFT
Godzdzies = Makebcd(godziny)       'zamieniamy liczb dwjkow na BCD
Godzjed = Godzdzies And 15  'uzyskujemy tylko cztery modsze bity - jednostki
Shift Godzdzies , Right , 4 'przesuwajc w prawo usuwany 4 modsze bity
'teraz wywietlamy jedn cyfr na wywietlaczu:
Mux = Uniwers And &B11 : Portd = &B1111111
Select Case Mux             ' obsuga wywietlacza
Case 0:                     'wywietl zawarto licznika jednostek minut
   Portb = Lookup(minjed , Tabela) : Portd.3 = 0
Case 1:                     'wywietl zawarto licznika dziesitek minut
   Portb = Lookup(mindzies , Tabela) : Portd.4 = 0
Case 2:                     'wywietl zawarto licznika jednostek godzin
   Portb = Lookup(godzjed , Tabela) : Portd.5 = 0 : Portb.7 = Migaj       'ew. wcz punkt dziesitny
Case 3:                     'wywietl zawarto licznika dziesiatek godzin
   Portb = Lookup(godzdzies , Tabela) : Portd.6 = 0
End Select : Return         'koniec obsugi przerwania od T/C0 co 4,096ms

Tabela:
Data 192 , 249 , 164 , 176 , 153 , 146 , 130 , 248 , 128 , 144




