'C017c  prosty zegar z ustawianiem OSZCZDNY
Dim Sekundy As Byte , Minuty As Byte , Godziny As Byte
Dim Sekjed As Byte , Sekdzies As Byte , Minjed As Byte
Dim Mindzies As Byte , Godzjed As Byte , Godzdzies As Byte , Mux As Byte
Dim Migaj As Bit , Uniwers As Byte , Maxi As Byte
Godziny = 15 : Minuty = 45  'na pocztek - godzina i minuta dobra, jak kada inna
Config Portb = 255 : Portb = &B11111111       'jak wyjscia
Config Portd = &B1111100 : Portd = &B1111111       'dwa najmodze - wejscia podciagnite
Config Timer0 = Timer , Prescale = 64       'zwikszanie Timer0 co 16ms (64*0,25us)
Config Timer1 = Timer , Prescale = 64       'zwikszanie Timer1 co 16ms (64*0,25us)
Enable Interrupts           'odblokowanie globalne systemu przerwa
Enable Timer0               'odblokowanie przerwania od Timera0
Enable Timer1               'odblokowanie przerwania od Timera1 (przepenienie licznika)
On Timer0 Co4ms             'po przepenieniu licznika 0 skocz do etykiety o nazwie Co4ms
On Timer1 Co1s              'po przepenieniu licznika 1 skocz do etykiety o nazwie Co1s
Uniwers = 4 : Maxi = 100    'wartoci pocztkowe zmiennych pomocniczych
Stop Ac                     'wycz zasilanie komparatora analogowego

Do                          'gwny program
' w kadym obiegu ptli sprawdzamy i korygujemy stany licznikw
   If Sekundy = 60 Then     'skrc cykl licznika Sekund 0...59
      Sekundy = 0 : Incr Minuty       'co 60s zwiksz stan licznika minut
   End If
   If Minuty = 60 Then      'liczy 0...59
      Minuty = 0 : Incr Godziny       'co 60min zwiksz stan licznika godzin
   End If
   If Godziny = 24 Then Godziny = 0       'liczy 0...23
If Pind.0 = 1 Then          'jeeli brak napicia sieci
   Portd = 127              'wyga wywietlacze
   Portb = 0                'likwiduje prd pynacy przez R15...R18 i kabel programujcy
   Disable Timer0           'zablokuj Timer0
   Idle                     'PRZEJD DO TRYBU IDLE
Else                        'jeli jest napicie sieci
   Enable Timer0            'w kadym obiegu ptli uruchamiamy T/C0, co nie przeszkadza
End If
Loop
End                         'koniec programu gwnego

Co1s:                       'co 1 sekund
Load Timer1 , 62500         '= Timer1=3036 '- eby przerwanie byo dokadnie co 1s
Incr Sekundy : Toggle Migaj : Return       'koniec obsugi przerwania od T/C1

Co4ms:                      'przerwanie co 4,096ms (bez skracania cyklu licznika T/C0))
Decr Uniwers                'obsuga wywietlaczy i przyciskw
If Pind.1 = 0 Then          'USTAWIANIE CZASU - tylko gdy przycisk S2 nacinity
   If Uniwers = 0 Then      'licznik pomocniczy Uniwers
      Uniwers = Maxi        'liczy w d, od Maxi do zera
      Incr Minuty           'i przycinity zwiksza stan licznika minut
      Sekjed = 0 : Sekdzies = 0       'zawsze te zeruje sekundy
      Maxi = Maxi - 4       'samoczynnie - coraz szybciej
      If Maxi < 4 Then Maxi = 4       'maksymalna szybko
   End If
Else                        'NORMALNA PRACA - gdy  S2 zwolniony
   If Uniwers = 0 Then      'licznik Uniwers wykorzystywany do multipleksu
      Uniwers = 4           'liczy od 4 do zera
      Maxi = 100            'pocztkowa warto Maxi (nie wykorzystana)
   End If
End If
'potem zamieniamy liczby dwjkowe na BCD
Mindzies = Makebcd(minuty) : Minjed = Mindzies And 15 : Shift Mindzies , Right , 4
Godzdzies = Makebcd(godziny) : Godzjed = Godzdzies And 15 : Shift Godzdzies , Right , 4
'teraz wywietlamy jedn cyfr na wywietlaczu:
Mux = Uniwers And &B11      'wykorzystamy dwa najmodsze bity licznika Uniwers
Portd = &B1111111           'wyga wywietlacze
Select Case Mux             ' obsuga wywietlacza
Case 0:                     'wywietl zawarto licznika jednostek minut
   Portb = Lookup(minjed , Tabela) : Portd.3 = 0
Case 1:                     'wywietl zawarto licznika dziesitek minut
   Portb = Lookup(mindzies , Tabela) : Portd.4 = 0
Case 2:                     'wywietl zawarto licznika jednostek godzin
   Portb = Lookup(godzjed , Tabela) : Portb.7 = Migaj : Portd.5 = 0
Case 3:                     'wywietl zawarto licznika dziesiatek godzin
   Portb = Lookup(godzdzies , Tabela) : Portd.6 = 0
End Select

Return                      'koniec obsugi przerwania od T/C0 co 4,096ms

Tabela:
Data 192 , 249 , 164 , 176 , 153 , 146 , 130 , 248 , 128 , 144