'C019h  Licznik rewersyjny 0...99 z konwersj BCD
' zmienna Licznik w EEPROM, wstpnie zaadowana tam liczba 47
' nie mona przeprowadza oblicze w EEPROM-ie - trzeba przepisywa zmienn
' podobnie nie mona operowa na 7-bitowym rejestrze Pind
' std obecnos zmiennych Pomoc i Przyciski ; S1 - w gr, S2 - w d
$eeprom
Data 192 , 249 , 164 , 176 , 153 , 146 , 130 , 248 , 128 , 144 , 47
Dim Licznik As Eram Byte At 10       'KONIECZNIE trzeba zadeklarowa adres
Dim Jednostki As Byte , Dziesiatki As Byte , Uniwers As Byte
Dim Pomoc As Byte , A As Byte , Mux As Byte , Maxi As Byte , Przyciski As Byte
Config Portb = 255 : Portb = 255 : Config Portd = &B1111100 : Portd = 127
Config Timer0 = Timer , Prescale = 64 : Enable Interrupts : Enable Timer0
On Timer0 Co4ms : Uniwers = 4 : Maxi = 60       'wartoci pocztkowe
Do : Loop : End     'to jest gwny program -  pusta nieskoczona ptla

Co4ms:              'przerwanie co 4,096ms
Decr Uniwers        'klasyczna obsuga "inteligentnych" przyciskw
If Uniwers = 0 Then ' na koniec cyklu licznika Uniwers:
   Przyciski = Pind 'nie mona wsprost z siedmiobitowym rejestrem Pind
   Przyciski = Przyciski And &B11       ' "wydubujemy" dwa najmodsze bity
   Select Case Przyciski       'sprawdzamy stan przyciskw
   Case 1:          'Pind.1 = 0 and Pind.0 = 1      ' przycisk "d" - S2
     Uniwers = Maxi : Maxi = Maxi - 8 : If Maxi < 8 Then Maxi = 8       'coraz szybciej
     Pomoc = Licznik       '         z EEPROMa do RAM
     Pomoc = Pomoc - 1       '    lub Decr Pomoc 'zmniejsza zawarto
     If Pomoc = 255 Then Pomoc = 0       'nie pozwala na "zawiniecie"
     Licznik = Pomoc       '  z powrotem z RAM-u do EEPROM-a
   Case 2:          ' Pind.0 = 0 And Pind.1 = 1 Then  'przycisk "gra" - S1
     Uniwers = Maxi : Maxi = Maxi - 8 : If Maxi < 8 Then Maxi = 8       'coraz szybciej
     Pomoc = Licznik : Incr Pomoc : If Pomoc = 100 Then Pomoc = 99 : Licznik = Pomoc
   Case Else:       'gdy S1, S2 zwolnione lub oba nacinite
     Uniwers = 4 : Maxi = 60
   End Select
End If
A = Licznik         'najpierw przepisujemy do RAM-u
A = Makebcd(a)      'zamieniamy liczb dwjkow na BCD
Jednostki = A And 15       ' AND i maska &B00001111 = 15
Dziesiatki = A : Shift Dziesiatki , Right , 4
Mux = Uniwers And &B1 : Portd = &B1111111       'Mux - 0, 1
Select Case Mux     ' obsuga wywietlacza
Case 0:             'wywietl zawarto  jednostek
  Readeeprom Portb , Jednostki : Portd.3 = 0
Case 1:             'wywietl zawarto  dziesitek
  Readeeprom Portb , Dziesiatki : Portd.4 = 0
End Select : Return 'koniec obsugi przerwania od T/C0 co 4,096ms