'C019i  Licznik rewersyjny 0...99 z konwersj BCD ulepszony wpis do EEPROM-a
$eeprom
Data 192 , 249 , 164 , 176 , 153 , 146 , 130 , 248 , 128 , 144 , 45
Dim Licznik As Eram Byte At 10       'KONIECZNIE trzeba zadeklarowa adres
Dim Jednostki As Byte , Dziesiatki As Byte , Mux As Byte , Wpis As Bit , Maxi As Byte
Dim Uniwers As Byte , Pomoc As Byte , A As Byte , Zero As Byte , Przyciski As Byte
Config Portb = 255 : Portb = 255 : Config Portd = &B1111100 : Portd = 127
Config Timer0 = Timer , Prescale = 64 : Enable Interrupts : Enable Timer0
On Timer0 Co4ms : Uniwers = 4 : Maxi = 60       'wartoci pocztkowe
Zero = 192          'bo nie mona wpisa liczby wprost do EEPROM-a
Writeeeprom Zero , 0       'na wszelki wypadek
Pomoc = Licznik     ' jednorazowo na pocztku przepisujemy z EEPROMa do RAM-u
Do : Loop : End     'to jest gwny program -  pusta nieskoczona ptla

Co4ms:              'przerwanie co 4,096ms
Decr Uniwers        'klasyczna obsuga "inteligentnych" przyciskw
If Uniwers = 0 Then ' na koniec cyklu licznika Uniwers:
   Przyciski = Pind 'nie mona wsprost z siedmiobitowym rejestrem Pind
   Przyciski = Przyciski And &B11       ' "wydubujemy" dwa najmodsze bity
   Select Case Przyciski       'sprawdzamy stan przyciskw
   Case 1:          'Pind.1 = 0 and Pind.0 = 1      ' przycisk "d" - S2
     Maxi = Maxi - 8 : If Maxi < 8 Then Maxi = 8 : Uniwers = Maxi       'coraz szybciej
     Wpis = 1       'ustaw flag nacinicia przyscisku
     Decr Pomoc     'zmniejsza, ale nie wpisuje do EEPROM-a
     If Pomoc = 255 Then Pomoc = 0       'nie pozwala na "zawiniecie" gdy dojdzie do 0
   Case 2:          ' Pind.0 = 0 And Pind.1 = 1 Then  'przycisk "gra" - S1
     Maxi = Maxi - 8 : If Maxi < 8 Then Maxi = 8 : Uniwers = Maxi       'coraz szybciej
     Wpis = 1       'ustaw flag nacinicia przyscisku
     Incr Pomoc     'zwiksza, ale nie wpisuje do EEPROM-a
     If Pomoc = 100 Then Pomoc = 99       'liczy 0...99
   Case Else:       'gdy S1, S2 zwolnione lub oba nacinite
     Uniwers = 4 : Maxi = 60       'zwyky cykl Uniwers (4...0)
     If Wpis = 1 Then       'po zwolnieniu przycisku
        Wpis = 0    '        jednorazowo
        Licznik = Pomoc       ' wpisuje now warto do EEPROM
     End If         '
   End Select
End If
A = Makebcd(pomoc)  'wywietlamy zawarto zmiennej Pomoc, nie Licznik
Jednostki = A And 15 : Dziesiatki = A
Shift Dziesiatki , Right , 4 : Mux = Uniwers And &B1 : Portd = 127
Select Case Mux     ' obsuga wywietlacza
 Case 0:            'wywietl zawarto  jednostek
  Readeeprom Portb , Jednostki : Portd.3 = 0
 Case 1:            'wywietl zawarto  dziesitek
  Readeeprom Portb , Dziesiatki : Portd.4 = 0
End Select : Return 'koniec obsugi przerwania od T/C0 co 4,096ms



