'   C021b    Prosta centralka alarmowa - kompletny program
'dwie linie dozorowe L1 -zwoczna - PD.5, L2-natychmiastowa - PD.6
'ukryty przecznik sterujcy = PD.1 (S2)
'przycisk S1 suy do kasowania wskazania alarmu na wywietlaczu
'PD.2 i Q2 - wyjcie do syreny alarmowej
Dim Stan As Byte
'( bajt stanu centralki
Stan.7 - Bit Niewykorzystany
Stan.6 - Flaga Czasu Alarmu
Stan.5 - Bit Pomocniczy Potrzebny Przy Waczaniu Czuwania
Stan.4 - Stan Klucza S2(za / Wyacz Alarm) : 1 -spoczynek 0 -praca
Stan.3 - L2 - Linia Natychmiastowa
Stan.2 - Flaga Czasu Na Wyjscie
Stan.1 - Flaga Czasu Na Wejscie
Stan.0 - L1 - Linia Z Opnieniem(zwoczna)                 ')
Dim Czasalarmu As Byte , Czaswyjscia As Byte , Czaswejscia As Byte
Enable Interrupts : Enable Timer1 : Config Timer1 = Timer , Prescale = 64
Config Watchdog = 2048 : Start Watchdog                     'reset po okoo 2 sekundach
On Timer1 Co500ms : Config Portb = Output                   ' portB - wyjcie
Config Portd = &B0000100                                    'PD.2 - wyjcie brzczyka, reszta - wejscia
Portd = 255                                                 'wszystkie wejcia podcignite; PD.2=1 - syrena wyczona
Portb = 127                                                 'wygasza wywietlacze, ale kropki mog wieci, bo PB.6=0
Stan = 0                                                    'po resecie stan  czuwania (!) - ze wzgldu na watchdoga
Const Czasal = 10                                           '240  'Czas alarmu liczba<255 ; 240*0,5s = 120s = 2 minuty
Const Czaswy = 8                                            '50   'Czas na wyjscie liczba<255 ; 50*0,5s = 25 sekund
Const Czaswe = 6                                            '30   'Czas na wyczenie alarmu liczba<255 30*0,5s = 15s

Do : Loop : End                                             'gwny program, jak zwykle...

Co500ms:                                                    'procedura obsugi przerwania od Timera1
Timer1 = 34286                                              'co daje 31250*16mikrosekund, czyli 0,5sekundy
Reset Watchdog                                              'gaszczemy psa, eby si nie zoci
'najpierw sprawdzamy stan linii L1, L2 oraz wej S1, S2
Stan.4 = Pind.1                                             'przepisz stan klucza
Stan.3 = Pind.6                                             'przepisz stan L2
Stan.0 = Pind.5                                             'przepisz stan L1
'tu mamy trzy liczniki czasu:
      If Stan.6 = 1 Then                                    'gdy flaga alarmu ustawiona
         Portb.6 = 0                                        'wcz segmenty g wywietlaczy
         Decr Czasalarmu                                    'zmniejsz zawarto licznika
         If Czasalarmu = 255 Then Stan.6 = 0                'zakocz odliczanie czasu
      Else                                                  'gdy flaga wyzerowana, czyli w spoczynku
         Czasalarmu = Czasal                                'przygotuj do nastpnego cyklu
      End If
If Stan.2 = 1 Then                                          'gdy flaga czasu na wyjcie ustawiona
   Portb.1 = 0                                              'wcz segmenty b wywietlaczy
   Decr Czaswyjscia                                         'zmniejsz zawarto licznika
   If Czaswyjscia = 255 Then Stan.2 = 0                     'zakocz odliczanie czasu
Else                                                        'gdy flaga wyzerowana, czyli w spoczynku
   Czaswyjscia = Czaswy                                     'przygotuj do nastpnego cyklu
   Portb.1 = 1                                              'oraz wyga segmenty b
End If
      If Stan.1 = 1 Then                                    'gdy flaga czasu na wejcie ustawiona
         Portb.5 = 0                                        'wcz segmenty f wywietlaczy
         Decr Czaswejscia                                   'zmniejsz zawarto licznika
         If Czaswejscia = 255 Then
            Stan.1 = 0                                      'zakocz odliczanie czasu na wejscie
            Stan.6 = 1                                      'wcz alarm
         End If
      Else                                                  'gdy flaga wyzerowana, czyli w spoczynku
         Czaswejscia = Czaswe                               'przygotuj do nastpnego cyklu
         Portb.5 = 1                                        'wyga segmenty f - wskanik czasu na wejscie
      End If
'tu sprawdzamy stan centralki:
If Stan.4 = 1 Then                                          'gdy centralka wyczona, czyli klucz S2 - rozwarty
   Stan = &B00110000                                        'oprcz wczeniej ustawionego bitu Stan.5 (S2)
   ' dodatkowo ustawiamy bit pomocniczy Stan.5, a reszt zerujemy
   If Pind.0 = 0 Then Portb = 127                           'gasi segment g - kasuje pami alarmu
Else                                                        'praca centralki: klucz S2 - zwarty
   If Stan.5 = 1 Then                                       ' jednorazowo po wczeniu czuwania
      Stan.2 = 1                                            'zablokujemy lini zwoczn i odmierzymy czas na wyjscie
      Stan.5 = 0                                            'jednorazowo, wic wyzeruj bit pomocniczy
   End If
   If Stan > 7 Then                                         'gdy pobudzona linia natychmiastowa L2 - zawsze wcz alarm
      Stan.6 = 1                                            'zacznij odmierza czas alarmu
   Else                                                     'gdy L2 nie pobudzona, wtedy Stan=0...7 i mona:
      If Stan = 1 Then Stan.1 = 1                           'zacz odmierza czas na wejcie
   End If
End If
Portb.0 = Stan.4                                            'segmenty a wiadcz o wczeniu czuwania centralki
Portd.2 = Not Stan.6                                        'ewentualnie wcz syren doczon do Q2
Return